/*
Copyright (c) 2014-2016 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

extern

Atom a_utf8_string,
  a_net_current_desktop,
  a_net_number_of_desktops,
  a_net_supported,
  a_net_client_list,
  a_net_client_list_stacking,
  a_net_wm_desktop,
  a_net_active_window,
  a_net_desktop_geometry,
  a_net_supporting_wm_check,
  a_net_wm_icon,
  a_net_wm_name,
  a_net_wm_visible_name,
  a_net_wm_icon_name,
  a_net_wm_visible_icon_name,
  a_net_wm_strut,
  a_net_wm_strut_partial,
  a_wm_name,
  a_wm_icon_name,
  a_wm_protocols,
  a_wm_delete_window,
  a_wm_window_role,
  a_wm_state,
  a_net_wm_window_type,
  a_net_wm_window_type_dock,
  a_net_wm_window_type_normal,
  a_net_wm_window_type_popup_menu,
  a_net_wm_state,
  a_net_wm_state_sticky,
  a_net_wm_state_skip_taskbar,
  a_net_wm_state_skip_pager,
  a_net_wm_state_hidden,
  a_net_wm_state_above,
  a_net_frame_extents,
  a_string;


void x_atoms_init();
int get_window_property
    (Window window, Atom property, Atom type,
     Atom *Rtype,int *Rformat,  int *Rsize, void **Rdata,
     unsigned long max_size);
int get_window_property_cardinals
    (Window window, Atom property, size_t *Rn, unsigned long **R, int maxn);
int get_window_property_cardinal
    (Window window, Atom property, unsigned long *R);
int get_window_property_windows
    (Window window, Atom property, size_t *Rn, Window **R, int maxn);
int get_window_property_atoms
    (Window window, Atom property, size_t *Rn, Atom **R, int maxn);
int get_window_property_window
    (Window window, Atom property, Window *R);
int get_window_property_utf8_string
    (Window window, Atom property, size_t *Rn, char **R);
int get_window_property_string
    (Window window, Atom property, size_t *Rn, char **R);
int set_window_property_atoms
        (Window window, Atom property, int n_values, Atom *values);
int set_window_property_cardinals
        (Window window, Atom property, int n_values, unsigned long *values);
int set_window_property_cardinal
        (Window window, Atom property, unsigned long value);
int set_window_property_string
        (Window window, Atom property, char *str);

